package MuGeN::CompAnalResultSource;

use strict;

use MuGeN::CompAnalResult;

use MuGeN::PreferencesHandler;



sub set_preferences {
    my $mugen=$MuGeN::PreferencesHandler::Preferences->getDocumentElement();
    my @nodes=$mugen->getElementsByTagName('resultdatasources');
    my $rdsources=undef;
    if (scalar(@nodes)==0) {
	my $doctype=$MuGeN::PreferencesHandler::Preferences->getDoctype();
	$doctype->addElementDecl('resultdatasources','(origamiresults|mosaicresults)*');
	$rdsources=$MuGeN::PreferencesHandler::Preferences->createElement('resultdatasources');
	$mugen->appendChild($rdsources);
    }
}

BEGIN {
    MuGeN::PreferencesHandler::register_listener(\&set_preferences);
}

sub _new {
    my $class=shift;
    my $logwindow=shift;
    my $self={};

    $self->{companalresults}=[];
    $self->{logwindow}=$logwindow;
    bless $self,$class;

    return $self;
}

sub get_results {
    my $self=shift;
    
    return $self->{companalresults};
}

sub set_log_window {
    my $self=shift;
    $self->{logwindow}=shift;
}

package MuGeN::CompAnalResultFactory;

use strict;

use XML::Parser::PerlSAX;

BEGIN {
    %MuGeN::CompAnalResultFactory::Factory=();
    my @modules=qw(BoxPlotResult BSFAMutantResult ExpressionDataResult HistogramResult LinePlotResult LinkPlotResult OperonsResult RegulatorySequenceResult RHOMResult);

    foreach my $module (@modules) {
	eval {
	    require "MuGeN/CompAnalResult/$module.pm";
	}
    }
}

1
