package MuGeN::Gui::MapListWindow;

use strict;

sub new {
 
    my $class=shift;
    my $manager=shift;

    my $self={};
    bless $self,$class;

    $self->{manager}=$manager;

    my $window=new Gtk2::Window -toplevel;
    $window->set_title('Map List');
    $window->signal_connect('delete_event',sub { $self->{manager}->change_window_visibility('listwindow',1); return 1});
    $window->signal_connect('destroy_event',sub { $self->{manager}->change_window_visibility('listwindow',1); return 1});     $self->{window}=$window;
    
    my $vbox=new Gtk2::VBox(0);
    $window->add($vbox);
    $vbox->show();

    my $maplistframe=new Gtk2::Frame 'Map Operations';
    $maplistframe->show();
    $vbox->pack_start($maplistframe,1,1,4);

    my $maplistvbox=new Gtk2::VBox(0);
    $maplistvbox->show();
    $maplistframe->add($maplistvbox);

    my $mapscrwindow=new Gtk2::ScrolledWindow;
    $mapscrwindow->set_policy('automatic','automatic');
    $maplistvbox->pack_start($mapscrwindow,1,1,1);
    $mapscrwindow->show();
    
    my $maplistmodel=Gtk2::ListStore->new("Glib::String");
    my $maplistview=Gtk2::TreeView->new_with_model($maplistmodel);
    $maplistview->insert_column_with_attributes(0,"Name",Gtk2::CellRendererText->new(),"text",0);
    $maplistview->set_headers_visible(0);
    my $maplistselection=$maplistview->get_selection();
    $maplistselection->signal_connect('changed',sub { $self->maplist_selection_changed();});
    $maplistview->show();
    $mapscrwindow->add_with_viewport($maplistview);
    $self->{maplistview}=$maplistview;
    my $hbox=new Gtk2::HBox(0);
    $hbox->show();
    $maplistvbox->pack_start($hbox,0,0,1);
    
    my $mapaddhbox=new Gtk2::HBox(0);
    $hbox->pack_start($mapaddhbox,1,1,1);

    my $mapdatasourcelabel=new Gtk2::Label('Data Source:');
    $mapdatasourcelabel->show();
    $mapaddhbox->pack_start($mapdatasourcelabel,1,1,1);

    my $mapdatasourceoptionmenu=new Gtk2::OptionMenu();
    $mapdatasourceoptionmenu->show();
    $mapdatasourceoptionmenu->set_history(0);
    $mapaddhbox->pack_start($mapdatasourceoptionmenu,1,1,1);
    $self->{mapdatasourceoptionmenu}=$mapdatasourceoptionmenu;

    $self->build_datasource_menu();

    my $mapaddbtn=new Gtk2::Button('Add');
    $mapaddbtn->signal_connect('clicked',sub { $self->add_map_from_datasource(); });
    $mapaddbtn->show();
    $mapaddhbox->pack_start($mapaddbtn,1,1,1);
    $self->{mapaddbtn}=$mapaddbtn;

    my $mapupbtn=new Gtk2::Button();
    my $uparrow=new Gtk2::Arrow('up','out');
    $mapupbtn->add($uparrow);
    $mapupbtn->set_sensitive(0);
    $mapupbtn->signal_connect('clicked',sub { $self->shift_map_up; });
    $mapupbtn->show();
    $hbox->pack_start($mapupbtn,1,1,1);
    $self->{mapupbtn}=$mapupbtn;

    my $mapdownbtn=new Gtk2::Button();
    my $downarrow=new Gtk2::Arrow('down','out');
    $mapdownbtn->add($downarrow);
    $mapdownbtn->set_sensitive(0);
    $mapdownbtn->signal_connect('clicked',sub { $self->shift_map_down; });
    $mapdownbtn->show();
    $hbox->pack_start($mapdownbtn,1,1,1);
    $self->{mapdownbtn}=$mapdownbtn;

    my $maphsbtn=new Gtk2::Button('Hide/Show');
    $maphsbtn->set_sensitive(0);
    $maphsbtn->signal_connect('clicked',sub { $self->hide_show_map; });
    $maphsbtn->show();
    $hbox->pack_start($maphsbtn,1,1,1);
    $self->{maphsbtn}=$maphsbtn;

    my $mapdupbtn=new Gtk2::Button('Duplicate');
    $mapdupbtn->set_sensitive(0);
    $mapdupbtn->signal_connect('clicked',sub { $self->duplicate_map; });
    $mapdupbtn->show();
    $hbox->pack_start($mapdupbtn,1,1,1);
    $self->{mapdupbtn}=$mapdupbtn;

    my $maprevcombtn=new Gtk2::Button('Flip');
    $maprevcombtn->set_sensitive(0);
    $maprevcombtn->signal_connect('clicked',sub { $self->revcom_map; });
    $maprevcombtn->show();
    $hbox->pack_start($maprevcombtn,1,1,1);
    $self->{maprevcombtn}=$maprevcombtn;

    my $mapsavebtn=new Gtk2::Button('Save');
    $mapsavebtn->set_sensitive(0);
    $mapsavebtn->signal_connect('clicked',sub { $self->save_map; });
    $mapsavebtn->show();
    $hbox->pack_start($mapsavebtn,1,1,1);
    $self->{mapsavebtn}=$mapsavebtn;

    my $mapremovebtn=new Gtk2::Button('Remove');
    $mapremovebtn->set_sensitive(0);
    $mapremovebtn->signal_connect('clicked',sub { $self->remove_map; });
    $mapremovebtn->show();
    $hbox->pack_start($mapremovebtn,1,1,1);
    $self->{mapremovebtn}=$mapremovebtn;
    
    my $positionvbox=new Gtk2::VBox(0,1);
    $maplistvbox->pack_start($positionvbox,0,0,0);

    my $anchorhbox=new Gtk2::HBox(0,1);
    $anchorhbox->show();
    $positionvbox->pack_start($anchorhbox,1,1,1);

    my $anchorlabel=new Gtk2::Label('Anchor (Position/Gene) :');
    $anchorlabel->show();
    $anchorhbox->pack_start($anchorlabel,0,0,1);
    my $anchorentry=new Gtk2::Entry;
    $anchorentry->show();
    $anchorentry->signal_connect('activate',sub {$self->anchor_changed;});
    $self->{anchorentry}=$anchorentry;
    $anchorhbox->pack_start($anchorentry,1,1,1);

    my $companalframe=new Gtk2::Frame 'Computational Result Operations';
    $companalframe->show();
    $vbox->pack_start($companalframe,1,1,4);

    my $companalvbox=new Gtk2::VBox(0,1);
    $companalvbox->show();
    $companalframe->add($companalvbox);    
    
    my $companalscrwindow=new Gtk2::ScrolledWindow;
    $companalscrwindow->set_policy('automatic','automatic');
    $companalvbox->pack_start($companalscrwindow,1,1,1);
    $companalscrwindow->show();
    
    my $companallistmodel=Gtk2::ListStore->new("Glib::String");
    my $companallistview=Gtk2::TreeView->new_with_model($companallistmodel);
    $companallistview->insert_column_with_attributes(0,"Name",Gtk2::CellRendererText->new(),"text",0);
    $companallistview->set_headers_visible(0);
    $companallistview->show();
    my $companallistselection=$companallistview->get_selection();
    $companallistselection->signal_connect('changed',sub { $self->companallist_selection_changed();});
    $self->{companallistview}=$companallistview;
    $companalscrwindow->add_with_viewport($companallistview);

   my  $computationalhbox=new Gtk2::HBox(0);
    $computationalhbox->show();
    $companalvbox->pack_start($computationalhbox,0,0,0);
    
    my $computationalsourcelabel=new Gtk2::Label('Computational Analysis Result Source:');
    $computationalsourcelabel ->show();
    $computationalhbox->pack_start($computationalsourcelabel,1,1,1);
    
    my $companalsourceoptionmenu=new Gtk2::OptionMenu();
    $companalsourceoptionmenu->show();
    $companalsourceoptionmenu->set_history(0);
    $computationalhbox->pack_start($companalsourceoptionmenu,1,1,1);
    $self->{companalsourceoptionmenu}=$companalsourceoptionmenu;

    $self->build_resultsource_menu();



    my $companaladdbtn=new Gtk2::Button('Add');
    $companaladdbtn->set_sensitive(0);
    $companaladdbtn->signal_connect('clicked',sub { $self->add_companal; return 1 });
    
    $companaladdbtn->show();
    $computationalhbox->pack_start($companaladdbtn,1,1,1);
    $self->{companaladdbtn}=$companaladdbtn;

    my $companalupbtn=new Gtk2::Button();
    $uparrow=new Gtk2::Arrow('up','out');
    $companalupbtn->add($uparrow);
    $companalupbtn->set_sensitive(0);
    $companalupbtn->signal_connect('clicked',sub { $self->move_companal_up; return 1 });
    
    $companalupbtn->show();
    $computationalhbox->pack_start($companalupbtn,1,1,1);
    $self->{companalupbtn}=$companalupbtn;

    my $companaldownbtn=new Gtk2::Button();
    $downarrow=new Gtk2::Arrow('down','out');
    $companaldownbtn->add($downarrow);
    $companaldownbtn->set_sensitive(0);
    $companaldownbtn->signal_connect('clicked',sub { $self->move_companal_down; return 1 });
    
    $companaldownbtn->show();
    $computationalhbox->pack_start($companaldownbtn,1,1,1);
    $self->{companaldownbtn}=$companaldownbtn;

    my $companalremovebtn=new Gtk2::Button('Remove');
    $companalremovebtn->set_sensitive(0);
    $companalremovebtn->signal_connect('clicked',sub { $self->remove_companal; return 1});
    $companalremovebtn->show();
    $computationalhbox->pack_start($companalremovebtn,1,1,1);
    $self->{companalremovebtn}=$companalremovebtn;
 
    return $self;
}

sub build_datasource_menu {
    my $self=shift;

    my $manager=$self->{manager};
    my $mapdatasourcemenu=Gtk2::Menu->new();
    my $mapdatasourceitem;

    if ( eval {require MuGeN::FeatureDataSource::FileFeatureDataSource;
	       require MuGeN::FeatureDataSourceWindow::FileWindow; } ) {
	my $filewindow=new MuGeN::FeatureDataSourceWindow::FileWindow($manager);
	$self->{filewindow}=$filewindow;
	$mapdatasourceitem=new Gtk2::MenuItem('Local File');
	$mapdatasourceitem->show();
	$mapdatasourceitem->signal_connect('activate',sub {$self->{datasourcetype}='Local File'; return 1});
	$mapdatasourcemenu->append($mapdatasourceitem);
    }

    if ( eval {require MuGeN::FeatureDataSource::MicadoFeatureDataSource; } &&
	 eval {require MuGeN::FeatureDataSourceWindow::MicadoWindow; } ) {
	if (MuGeN::FeatureDataSource::MicadoFeatureDataSource::init()) {
	    my $micadowindow=new MuGeN::FeatureDataSourceWindow::MicadoWindow($manager);
	    $self->{micadowindow}=$micadowindow;
	    $mapdatasourceitem=new Gtk2::MenuItem('Micado');
	    $mapdatasourceitem->show();
	    $mapdatasourceitem->signal_connect('activate',sub {$self->{datasourcetype}='Micado'; return 1});
	    $mapdatasourcemenu->append($mapdatasourceitem);
	}
    }
    
    if ( eval {require MuGeN::FeatureDataSource::AgmialFeatureDataSource; } &&
	 eval {require MuGeN::FeatureDataSourceWindow::AgmialWindow; } ) {
	if (MuGeN::FeatureDataSource::AgmialFeatureDataSource::init()) {
	    my $agmialwindow=new MuGeN::FeatureDataSourceWindow::AgmialWindow($manager);
	    $self->{agmialwindow}=$agmialwindow;
	    $mapdatasourceitem=new Gtk2::MenuItem('Agmial');
	    $mapdatasourceitem->show();
	    $mapdatasourceitem->signal_connect('activate',sub {$self->{datasourcetype}='Agmial'; return 1});
	    $mapdatasourcemenu->append($mapdatasourceitem);
	}
    }
    if ( eval {require MuGeN::FeatureDataSource::MosaicFeatureDataSource; } &&
	 eval {require MuGeN::FeatureDataSourceWindow::MosaicWindow; } ) {
	if (MuGeN::FeatureDataSource::MosaicFeatureDataSource::init()) {
	    my $mosaicwindow=new MuGeN::FeatureDataSourceWindow::MosaicWindow($manager);
	    $self->{mosaicwindow}=$mosaicwindow;
	    $mapdatasourceitem=new Gtk2::MenuItem('Mosaic');
	    $mapdatasourceitem->show();
	    $mapdatasourceitem->signal_connect('activate',sub {$self->{datasourcetype}='Mosaic'; return 1});
	    $mapdatasourcemenu->append($mapdatasourceitem);
	}
    }

    if ( eval {require MuGeN::FeatureDataSource::SeqDBFeatureDataSource; } &&
	 eval {require MuGeN::FeatureDataSourceWindow::SeqDBWindow; } ) {
	if (MuGeN::FeatureDataSource::SeqDBFeatureDataSource::init()) {
	    my $seqdbwindow=new MuGeN::FeatureDataSourceWindow::SeqDBWindow($manager);
	    $self->{seqdbwindow}=$seqdbwindow;
	    $mapdatasourceitem=new Gtk2::MenuItem('SeqDB');
	    $mapdatasourceitem->show();
	    $mapdatasourceitem->signal_connect('activate',sub {$self->{datasourcetype}='SeqDB'; return 1});
	    $mapdatasourcemenu->append($mapdatasourceitem);
	}
    }


    if ( eval {require MuGeN::FeatureDataSource::OrigamiFeatureDataSource; } &&
	 eval {require MuGeN::FeatureDataSourceWindow::OrigamiWindow; } ) {
	if (MuGeN::FeatureDataSource::OrigamiFeatureDataSource::init()) {
	    my $origamiwindow=new MuGeN::FeatureDataSourceWindow::OrigamiWindow($manager);
	    $self->{origamiwindow}=$origamiwindow;
	    $mapdatasourceitem=new Gtk2::MenuItem('Origami');
	    $mapdatasourceitem->show();
	    $mapdatasourceitem->signal_connect('activate',sub {$self->{datasourcetype}='Origami'; return 1});
	    $mapdatasourcemenu->append($mapdatasourceitem);
	}
    }

    if ( eval {require MuGeN::FeatureDataSource::EMBLFeatureDataSource;
	       require MuGeN::FeatureDataSourceWindow::EMBLWindow;} ) {
	my $emblwindow=new MuGeN::FeatureDataSourceWindow::EMBLWindow($manager);
	$self->{emblwindow}=$emblwindow;
	$mapdatasourceitem=new Gtk2::MenuItem('EMBL');
	$mapdatasourceitem->show();
	$mapdatasourceitem->signal_connect('activate',sub {$self->{datasourcetype}='EMBL'; return 1});
	$mapdatasourcemenu->append($mapdatasourceitem);
    }


    if ( eval {require MuGeN::FeatureDataSource::GenBankFeatureDataSource;
	       require MuGeN::FeatureDataSourceWindow::GenBankWindow;} ) {
	my $genbankwindow=new  MuGeN::FeatureDataSourceWindow::GenBankWindow($manager);
	$self->{genbankwindow}=$genbankwindow;
	$mapdatasourceitem=new Gtk2::MenuItem('GenBank');
	$mapdatasourceitem->show();
	$mapdatasourceitem->signal_connect('activate',sub {$self->{datasourcetype}='GenBank'; return 1});
	$mapdatasourcemenu->append($mapdatasourceitem);
    }


    if ($self->{mapdatasourcemenu}) {
	$self->{mapdatasourcemenu}->destroy();
    }
    
    $self->{mapdatasourcemenu}=$mapdatasourcemenu;
    $self->{mapdatasourceoptionmenu}->set_menu($mapdatasourcemenu);

    $mapdatasourcemenu->show();
    $self->{datasourcetype}='Local File';    

}

sub build_resultsource_menu {
    my $self=shift;

    my $manager=$self->{manager};
    my $computationalsourcemenu=Gtk2::Menu->new();

    if ( eval {require MuGeN::CompAnalResultSource::FileResultSource;
	       require MuGeN::CompAnalResultSourceWindow::FileWindow; } ) {
	my $companalresultwindow=new MuGeN::CompAnalResultSourceWindow::FileWindow($manager);
	$self->{companalresultwindow}=$companalresultwindow;
	my $computationalsourceitem=new Gtk2::MenuItem('Local File');
	$computationalsourceitem->show();
	$computationalsourceitem->signal_connect('activate',sub {$self->{companalsourcetype}='Local File'; return 1});
	$computationalsourcemenu->append($computationalsourceitem);
    }

    if ( eval {	require MuGeN::CompAnalResultSource::OrigamiResultSource;
		require MuGeN::CompAnalResultSourceWindow::OrigamiResultsWindow; } ) {
	if (MuGeN::CompAnalResultSource::OrigamiResultSource::init()) {
	    my $origamiresultswindow=new MuGeN::CompAnalResultSourceWindow::OrigamiResultsWindow($manager);
	    $self->{origamiresultswindow}=$origamiresultswindow;
	    my $computationalsourceitem= new Gtk2::MenuItem('Origami');
	    $computationalsourceitem->show();
	    $computationalsourceitem->signal_connect('activate',sub {$self->{companalsourcetype}='Origami'; return 1}); 
	    $computationalsourcemenu->append($computationalsourceitem);
	}
    }

    if ( eval {	require MuGeN::CompAnalResultSource::MosaicResultSource::MosaicResultHandler;
		require MuGeN::CompAnalResultSource::MosaicResultSource::MosaicCompAnalResult;
		require MuGeN::CompAnalResultSourceWindow::MosaicResultsWindow; } ) {
	if (MuGeN::CompAnalResultSource::MosaicResultSource::MosaicResultHandler::init()) {
	    my $mosaicresultswindow=new MuGeN::CompAnalResultSourceWindow::MosaicResultsWindow($manager);
	    $self->{mosaicresultswindow}=$mosaicresultswindow;
	    my $computationalsourceitem= new Gtk2::MenuItem('Mosaic');
	    $computationalsourceitem->show();
	    $computationalsourceitem->signal_connect('activate',sub {$self->{companalsourcetype}='Mosaic'; return 1}); 
	    $computationalsourcemenu->append($computationalsourceitem);
	}
    }

 if ( eval {require MuGeN::CompAnalResultSource::PatternSearchSource;
	       require MuGeN::CompAnalResultSourceWindow::PatternSearchWindow; } ) {
	my $companalresultwindow=new MuGeN::CompAnalResultSourceWindow::PatternSearchWindow($manager);
	$self->{patternsearchwindow}=$companalresultwindow;
	my $computationalsourceitem=new Gtk2::MenuItem('Pattern Search');
	$computationalsourceitem->show();
	$computationalsourceitem->signal_connect('activate',sub {$self->{companalsourcetype}='Pattern Search'; return 1});
	$computationalsourcemenu->append($computationalsourceitem);
    }

    if ( eval {require MuGeN::CompAnalResultSource::GCContentSource;
	       require MuGeN::CompAnalResultSourceWindow::GCContentWindow; } ) {
	my $companalresultwindow=new MuGeN::CompAnalResultSourceWindow::GCContentWindow($manager);
	$self->{gccontentwindow}=$companalresultwindow;
	my $computationalsourceitem=new Gtk2::MenuItem('GC Content');
	$computationalsourceitem->show();
	$computationalsourceitem->signal_connect('activate',sub {$self->{companalsourcetype}='GC Content'; return 1});
	$computationalsourcemenu->append($computationalsourceitem);
    }

    if ( eval {require MuGeN::CompAnalResultSource::GCSkewSource;
	       require MuGeN::CompAnalResultSourceWindow::GCSkewWindow; } ) {
	my $companalresultwindow=new MuGeN::CompAnalResultSourceWindow::GCSkewWindow($manager);
	$self->{gcskewwindow}=$companalresultwindow;
	my $computationalsourceitem=new Gtk2::MenuItem('GC Skew');
	$computationalsourceitem->show();
	$computationalsourceitem->signal_connect('activate',sub {$self->{companalsourcetype}='GC Skew'; return 1});
	$computationalsourcemenu->append($computationalsourceitem);
    }

    if ( eval {require MuGeN::CompAnalResultSource::CumulatedGCSkewSource;
	       require MuGeN::CompAnalResultSourceWindow::CumulatedGCSkewWindow; } ) {
	my $companalresultwindow=new MuGeN::CompAnalResultSourceWindow::CumulatedGCSkewWindow($manager);
	$self->{cumulatedgcskewwindow}=$companalresultwindow;
	my $computationalsourceitem=new Gtk2::MenuItem('Cumulated GC Skew');
	$computationalsourceitem->show();
	$computationalsourceitem->signal_connect('activate',sub {$self->{companalsourcetype}='Cumulated GC Skew'; return 1});
	$computationalsourcemenu->append($computationalsourceitem);
    }

    if ($self->{companalsourcemenu}) {
	$self->{companalsourcemenu}->destroy();
    }

    $self->{companalsourcemenu}=$computationalsourcemenu;
    $self->{companalsourceoptionmenu}->set_menu($computationalsourcemenu);

    $computationalsourcemenu->show();
    $self->{companalsourcetype}='Local File';    
}

sub add_map_from_datasource {
    my $self=shift;

    $self->{filewindow}->show()
	if ($self->{datasourcetype} eq 'Local File');
    $self->{agmialwindow}->show()
	if ($self->{datasourcetype} eq 'Agmial');
    $self->{micadowindow}->show()
	if ($self->{datasourcetype} eq 'Micado');
    $self->{mosaicwindow}->show()
	if ($self->{datasourcetype} eq 'Mosaic');
    $self->{seqdbwindow}->show()
	if ($self->{datasourcetype} eq 'SeqDB');
    $self->{origamiwindow}->show()
	if ($self->{datasourcetype} eq 'Origami');
    $self->{emblwindow}->show()
	if ($self->{datasourcetype} eq 'EMBL');
    $self->{xemblwindow}->show()
	if ($self->{datasourcetype} eq 'XEMBL');
    $self->{genbankwindow}->show()
	if ($self->{datasourcetype} eq 'GenBank');
    return 1;
}

sub add_map {
    my $self=shift;
    my $mapinfo=shift;

    my $maplistview=$self->{maplistview};

    my $model=$maplistview->get_model();
    my $iter=$model->append();
    $model->set($iter,0,$mapinfo->get_name);
    my $selection=$maplistview->get_selection();
    $selection->select_iter($iter);
    my $anchor=$mapinfo->get_anchor();
    $self->{anchorentry}->set_text($anchor->{display});
}

sub shift_map_up {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);
	my $path=$model->get_path($iterselect);
	if ($path->prev()) {
	    my $iterbefore=$model->get_iter($path);
	    $model->swap($iterselect,$iterbefore);
	    $self->{manager}->shift_map_up($mapname);
	}
    }
    return 1;
}

sub shift_map_down {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);
	my $path=$model->get_path($iterselect);
	$path->next();
	my $iterafter=$model->get_iter($path);
	if ($iterafter) {
	    $model->swap($iterselect,$iterafter);
	    $self->{manager}->shift_map_down($mapname);
	}
    }

    return 1;
}

sub hide_show_map {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);
	my $newname=$self->{manager}->hide_show_map($mapname);
	$model->set($iterselect,0,$newname);
    }
    return 1;

}

sub duplicate_map {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);
	$self->{manager}->duplicate_map($mapname);
    }
    return 1;
}


sub revcom_map {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);
	my $newname=$self->{manager}->revcom_map('NAME'=>$mapname);
	$model->set($iterselect,0,$newname);
	my $anchor=$self->{manager}->get_mapinfo('NAME'=>$newname);
	$self->{anchorentry}->set_text($anchor->{display});
    }
    return 1;
}


sub remove_map {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);
	$model->remove($iterselect);
	$self->{manager}->remove_map($mapname);

    }
    return 1;
}

sub save_map {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);
	if (!defined $self->{savewindow}) {
	    my $filewindow=new Gtk2::FileSelection('Save Map');
	    $self->{savewindow}=$filewindow;
	    $filewindow->ok_button->signal_connect('clicked',
						   sub {$self->save_map_filename_selected($mapname)});
	    $filewindow->cancel_button->signal_connect('clicked',
						       sub { $self->{savewindow}->hide(); return 1});
	    
	}
	
	my $filename=$mapname;
	$filename =~ s/\(.*\)//g;
	$filename =~ s/\s-\sChr.*$//;
	$filename =~ tr/ /_/;
	$filename .='.gbk';
	$self->{savewindow}->set_filename($filename);
	$self->{savewindow}->show();
    }

    return 1;
}

sub save_map_filename_selected {
    my $self=shift;
    my $mapname=shift;

    my $filename=$self->{savewindow}->get_filename();
    $self->{savewindow}->hide();
    $self->{manager}->save_map_to_file($mapname,$filename);

    return 1;
}

sub maplist_selection_changed {
    my $self=shift;

    my $mapname=undef;
    my $maplistview=$self->{maplistview};
    my $selection=$maplistview->get_selection();
    my $rowselected=$selection->count_selected_rows();

    if (!$rowselected) {
	$self->{companallistview}->set_sensitive(0);
	$self->{mapsavebtn}->set_sensitive(0);
	$self->{mapremovebtn}->set_sensitive(0);
	$self->{maphsbtn}->set_sensitive(0);
	$self->{mapupbtn}->set_sensitive(0);
	$self->{mapdownbtn}->set_sensitive(0);
	$self->{mapdupbtn}->set_sensitive(0);
	$self->{maprevcombtn}->set_sensitive(0);
	$self->{anchorentry}->delete_text(0,-1);
	$self->{anchorentry}->set_sensitive(0);
    } else {
	$self->{maphsbtn}->set_sensitive(1);
	$self->{mapdupbtn}->set_sensitive(1);
	$self->{maprevcombtn}->set_sensitive(1);
	$self->{companallistview}->set_sensitive(1);
	$self->{anchorentry}->set_sensitive(1);
	my ($model,$iter)=$selection->get_selected();
	$mapname=$model->get($iter,0);
	my $mapinfo=$self->{manager}->get_mapinfo('NAME'=>$mapname);
	my $anchor=$mapinfo->get_anchor();
	$self->{anchorentry}->set_text($anchor->{display});
	$self->{mapsavebtn}->set_sensitive(1);
	if ($model->iter_n_children()>0) {
	    $self->{mapremovebtn}->set_sensitive(1);
	    $self->{mapupbtn}->set_sensitive(1);
	    $self->{mapdownbtn}->set_sensitive(1);
	}
    }
    $self->refresh_companal_widgets($mapname);

    return 1;
}

sub anchor_changed {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);
	my $newanchor=$self->{anchorentry}->get_text();
	my $mapinfo=$self->{manager}->get_mapinfo('NAME'=>$mapname);
	$self->{manager}->set_anchor('NAME'=> $mapname,$newanchor);
	my $newname=$mapinfo->get_name();
	$model->set($iterselect,0,$newname);
	$newanchor=$mapinfo->get_anchor()->{display};
	$self->{anchorentry}->set_text($newanchor);
    }
    return 1;

}

sub refresh_companal_widgets {
    my $self=shift;
    my $mapname=shift;

    my $model=$self->{companallistview}->get_model();
    $model->clear();

    if (!defined $mapname) {
	$self->{companallistview}->set_sensitive(0);
	$self->{companaladdbtn}->set_sensitive(0);
	$self->{companalupbtn}->set_sensitive(0);
	$self->{companaldownbtn}->set_sensitive(0);
	$self->{companalremovebtn}->set_sensitive(0);
    } else {
	$self->{companallistview}->set_sensitive(1);
	$self->{companaladdbtn}->set_sensitive(1);
	my @companalnames=$self->{manager}->get_companal_names($mapname);
	my $companalmodel=$self->{companallistview}->get_model();
	foreach my $companalname (@companalnames) {
	    my $iter=$companalmodel->append();
	    $companalmodel->set($iter,0,$companalname);
	}
#	    $self->{companallist}->select_child($lastitem)
#		if (defined $lastitem);
    }

}


sub companallist_selection_changed {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if (!$selection->count_selected_rows) {
	$self->{companalupbtn}->set_sensitive(0);
	$self->{companaldownbtn}->set_sensitive(0);
	$self->{companalremovebtn}->set_sensitive(0);
    } else {
	$self->{companalupbtn}->set_sensitive(1);
	$self->{companaldownbtn}->set_sensitive(1);
	$self->{companalremovebtn}->set_sensitive(1);
    }

    return 1;
}

sub update_comp_anal_list {
    my $self=shift;
    my $mapname=shift;

    my $model=$self->{companallistview}->get_model();
    $model->clear();

    my @companalnames=$self->{manager}->get_companal_names($mapname);
    foreach my $name (@companalnames) {
	my $iter=$model->append();
	$model->set($iter,0,$name);
    }
}

sub add_companal {
    my $self=shift;

    my $selection=$self->{maplistview}->get_selection();
    if ($selection->count_selected_rows) {
	my ($model,$iterselect)=$selection->get_selected();
	my $mapname=$model->get($iterselect,0);


	my $resultsourcewindow=undef;
	$resultsourcewindow=$self->{origamiresultswindow}
	if ($self->{companalsourcetype} eq 'Origami');
	$resultsourcewindow=$self->{mosaicresultswindow}
	if ($self->{companalsourcetype} eq 'Mosaic');
	$resultsourcewindow=$self->{patternsearchwindow}
	if ($self->{companalsourcetype} eq 'Pattern Search');
	$resultsourcewindow=$self->{gccontentwindow}
	if ($self->{companalsourcetype} eq 'GC Content');
	$resultsourcewindow=$self->{gcskewwindow}
	if ($self->{companalsourcetype} eq 'GC Skew');
	$resultsourcewindow=$self->{cumulatedgcskewwindow}
	if ($self->{companalsourcetype} eq 'Cumulated GC Skew');
	$resultsourcewindow=$self->{companalresultwindow}
	if ($self->{companalsourcetype} eq 'Local File');	
	if (defined $resultsourcewindow) {
	    $resultsourcewindow->set_map_name($mapname);
	    $resultsourcewindow->show();
	}
    }
    return 1;
}

sub move_companal_up {
    my $self=shift;

    my $mapselection=$self->{maplistview}->get_selection();
    my $companalselection=$self->{companallistview}->get_selection();
    if ($mapselection->count_selected_rows && $companalselection->count_selected_rows) {
	my ($model,$iterselect)=$mapselection->get_selected();
	my $mapname=$model->get($iterselect,0);
	my ($model,$iterselect)=$companalselection->get_selected();
	my $companalname=$model->get($iterselect,0);
	
	$self->{manager}->move_companal_result_up($mapname,$companalname);

	$self->refresh_companal_widgets($mapname);
    }

    return 1;
}

sub move_companal_down {
    my $self=shift;
    
    my $mapselection=$self->{maplistview}->get_selection();
    my $companalselection=$self->{companallistview}->get_selection();
    if ($mapselection->count_selected_rows && $companalselection->count_selected_rows) {
	my ($model,$iterselect)=$mapselection->get_selected();
	my $mapname=$model->get($iterselect,0);
	my ($model,$iterselect)=$companalselection->get_selected();
	my $companalname=$model->get($iterselect,0);
	
	$self->{manager}->move_companal_result_down($mapname,$companalname);

	$self->refresh_companal_widgets($mapname);
    }

    return 1;
}

sub remove_companal {
    my $self=shift;

    my $mapselection=$self->{maplistview}->get_selection();
    my $companalselection=$self->{companallistview}->get_selection();
    if ($mapselection->count_selected_rows && $companalselection->count_selected_rows) {
	my ($model,$iterselect)=$mapselection->get_selected();
	my $mapname=$model->get($iterselect,0);
	my ($model,$iterselect)=$companalselection->get_selected();
	my $companalname=$model->get($iterselect,0);

	$self->{manager}->remove_companal_result($mapname,$companalname);

	$self->refresh_companal_widgets($mapname);
    }

    return 1;
}

sub show_all {
    my $self=shift;

    $self->{window}->show_all();

}

sub destroy {
    my $self=shift;

    $self->{window}->destroy();
}

1
